/*
 * Processor.java
 *
 * Copyright (C) 2008 P�r Crusefalk and Rein Couperus
 * Adapted for Android by John Douyere (VK2ETA)
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.AndFlmsg;

import java.util.Calendar;
import java.util.concurrent.Semaphore;
import java.util.logging.Level;
import java.util.logging.Logger;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.net.*;
import java.io.*;
import java.util.Random;

import android.app.Notification;
import android.app.NotificationManager;
import android.app.Service;
import android.content.Intent;
import android.os.Environment;
import android.os.IBinder;

/**
 *
 * @author Per jPskmail Main.java 
 * 
 */
public class Processor extends Service{

	static String application ="AndFlmsg A0.0.3"; // Used to preset an empty status 
	static String version = "Version A0.0.2, 2014-05-12";
	public static int RxFrequencyOffset = 0;
	public static boolean showallcharacters = false; //debugging
	public static boolean justReceivedRSID = false;

	static boolean onWindows = true;
	static String ModemPreamble="";  // String to send before each frame
	static String ModemPostamble=""; // String to send after each frame
//	static modemmodeenum Mymode = modemmodeenum.PSK250;
	static modemmodeenum[] modeprofile ;
//	static modemmodeenum linkmode = modemmodeenum.PSK250;
	static int modemnumber = 0;
	static modemmodeenum defaultmode = modemmodeenum.PSK250;
	static String CurrentModemProfile = "0";
	static int sending_link = 5;
	static int sending_beacon = 0;
	static boolean CBeacon = true;
	static String HomePath = "";
	static String Dirprefix = "";
	static String Separator = "";
	static String  Mailoutfile = "";
	static File pending = null;
	static String tempHtmlDir = "";
	static String Pendingdir = "";
	static String Outpendingdir = "";
	static File consolelog = null;
	static String Transactions = "";
	static boolean compressedmail = false;
	static boolean Bulletinmode = false;
	static boolean IACmode = false;
	static boolean comp = false;
	static boolean debug = false;
	static String Sendline = "";
	static String SendCommand="";
	static String telnethost = "";
	static String telnetport = "";
	static String userid = "";
	static String pass = "";
	static String CrcString = "";
	static String FileNameString = "";
	static int DCD  = 0;
	static int MAXDCD = 3;
	static int Persistence = 4;
	static boolean  BlockActive = false;
	static boolean EOTrcv = false;
	static int RXBlocksize = 0;
	static int Totalbytes = 0;
	static boolean  TXActive = false;
	static boolean TXID = false;
	static int Second = 30;  // Beacon second
	/*/   static String[] Modes = {"       ","THOR8","MFSK16","THOR22",
   "MFSK32",  "PSK250R", "PSK500R", "PSK500", "PSK250"};
static String[] AltModes = {"       ","THOR8","MFSK16","THOR22",
   "MFSK32",  "PSK125R", "PSK250R", "PSK250", "PSK250"};
	 */
	static String[] Modes = {"       ","THOR8","MFSK16","THOR22",
		"MFSK32",  "PSK250R", "PSK500R", "PSK500", "PSK250"};
	static String[] AltModes = {"       ","THOR8","MFSK16","THOR22",
		"MFSK32",  "PSK125R", "PSK250R", "PSK250", "PSK250"};
	static boolean UseAlttable = false;
	static String modelist = "789a"; //PSK500 to SPK63 only at this point. Was "7654321";
	static modemmodeenum TxModem = modemmodeenum.PSK250;
	static modemmodeenum RxModem = modemmodeenum.PSK250;
	static modemmodeenum Modemarray[];
	static String RxModemString = "PSK250";
	static int AudioFrequency = 1000; 

	//Semaphores to instruct the RxTx Thread to start or stop
	public static Semaphore restartRxModem = new Semaphore(1, false);
	public static Semaphore StopProcessor = new Semaphore(1, false);

	private NotificationManager myNotificationMgr;

	// globals to pass info to gui windows
	static String monitor = "";
	static String TXmonitor = "";
	static boolean monmutex = false;
	static String mainwindow = "";
	static String APRSwindow = "";
	static boolean mainmutex = false;
	static String MSGwindow = "";
	static String Mailheaderswindow = "";
	static String FilesTextArea = "";
	static String Status = "Listening";
	static String Statusline = "";
	static int StatusLineTimer;
	static boolean txbusy = false;
	static boolean rxbusy = false;
	static boolean autolink = true;
	static int protocol = 1;
	static String protocolstr = "1";
	static int cpuload;

	// globals for communication
	static String Icon;
	static int APRSMessageNumber;
	static String APRS_Server = "netherlands.aprs2.net";
	static  String mycall;     // mycall from options
	static String myserver;    // myserver from options
	static String TTYCaller;     // TTY caller
	static String TTYConnected = "";
	static String Motd = "";
	static boolean disconnect = false;
	static long Systime;
	static int DCDthrow;
	static String connectsecond;
	static long oldtime = 0;
	static long blockval = 0; //msec 
	static int charval = 0; //msecs
	static int chartime = 0;
	static int blocktime; // seconds
	static int idlesecs = 0;
	static String LastBlockExchange = "  ";
	static long LastSessionExchangeTime = 0;
	static boolean isDisconnected = false;
	static boolean ReceivingForm = false;
	static boolean Connecting = false;
	static boolean Aborting = false;
	static boolean Scanning = false;
	static boolean linked = false; // flag for link ack
	static String linkedserver = "";
	static String session = ""; // present session
	static boolean validblock = true;
	static String myrxstatus = "   "; // last rx status
	static String TX_Text; // output queue
	static int Progress = 0;
	static String DataSize = "";
	static String Servers[] = {"","","","","","","","","",""};
	static double AvgTxMissing = 0;
	static double AvgRxMissing = 0;
	static double hiss2n = 50;
	static double mys2n = 50;
	static double snr = 0.0;
	static double avgsnr = 50; //midrange
	static double SNR[] = {0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0};
	static String Lastheard[] = {"","","","","","","","","",""};
	static int packets_received[] = {0,0,0,0,0,0,0,0,0,0};
	static String modes_received[] = {"","","","","","","","","",""};
	static int strength[] = {0,0,0,0,0,0,0,0,0,0};
	static int snr_db = 0;
	static int TimeoutPolls = 0;
	static boolean JustDowngradedRX = false;
	static boolean status_received = false;
	static int NumberOfAcks = 5;
	static int Freq_offset = 1000;
	// Positions
	static String Positions [][] = new String [100][5];
	// GPS handles
	//JD Integrated GPS only at this point
	//   static serialport gpsport;    // Serial port object
	//   static nmeaparser gpsdata;    // Parser for nmea data
	// gpsd data
	static boolean HaveGPSD = false;
	static boolean WantGpsd = false;
	static boolean NewGPSD = false;
	static boolean WantRigctl = false;
	static boolean wantScanner = false;
	static boolean Scanenabled = true;
	static String CurrentFreq = "0";
	static String ServerFreq = "0";
	static String freqstore = "0";
	static boolean summoning = false;
	static String GPSD_latitude =  "";
	static String GPSD_longitude =  "";
	static Socket gpsdSocket = null;
	static PrintWriter gpsdout = null;
	static BufferedReader gpsdin = null;
	static String gpsd_data[] = {"","","","","","","","","","","","","","","","","","","",""};
	static long t1 = System.currentTimeMillis();
	static boolean wantigate = false;

	//crypto
	static String strkey = "1234";
	static String Passwrd = "password";
	static String hispubkey = "";
	static crypt cr = null;
	static String serverversion = "1.1";
	static double sversion = 1.1;
	static Session sm = null;

	static String aprsbeacontxt = "";
	static boolean Serverbeacon = false;


	// arq object
	static arq q;
	// Config object
	//not used in Android   static config configuration; // Static config object
	// Error handling and logging object
	static loggingclass log;

	// Our main window
	//   static mainpskmailui mainui;

	// Modem handle
	static public Modem m;

	// File handles
	static FileWriter bulletin = null;
	static FileReader hdr = null;
	// DCD
	static String DCDstr;
	// APRS server socket
	//JD Not now   static aprsmapsocket mapsock;
	//   static boolean aprsserverenabled = true;
	//   static Integer aprsserverport=8063;


	/**
	 * @param args the command line arguments
	 */
	//   public static void main(String[] args) throws InterruptedException {
	public static void processor() {

		//Nothing as this is a service
	}

	@Override
	public void onCreate() {

		// Create error handling class
		log = new loggingclass("AndFlmsg");

		// Call the folder handling method
		// Moved into oncreate() of main activity
		// handlefolderstructure();

		// Create config object
		// done in main class        configuration = new config(HomePath + Dirprefix);


		// Make arq object
		q = new arq();

		// Make calendar object
		//           Calendar cal = Calendar.getInstance();

		// Get settings and initialize
		handleinitialization();

		/* not on Android            
        if (WantGpsd & !onWindows){
            handlegpsd();
        }
		 */
		// Handle GPS

		if (!HaveGPSD) 
			handlegps();
		// Make session object
		sm = new Session();  // session, class

		//New Modem
		m = new Modem();
		//Reset frequency and squelch
		m.reset();

		q.Message(version, 10);

		// init random generator for DCD
		Random generator = new Random();

		//Always have RXid ON so that TTY connects and igates beacons can be heard on any mode
		q.send_rsid_command("ON");

		//Make sure the display strings are blank
		Processor.monitor = "";
		Processor.TXmonitor = "";
		Processor.mainwindow = "";
		Processor.APRSwindow = "";

	}


	@Override
	public int onStartCommand(Intent intent, int flags, int startId) {
		// Start the RxThread
		if (m != null) {
			m.startmodem();
			
			// Use a ticker to notify user of the modem running in the background
			CharSequence text = getText(R.string.Modem_Running);

			// Set the scrolling text (JD FIX that)
			Notification notification = new Notification(0, text, 0);

			//JD make sure Android keeps this running even if resources are restrained
			startForeground(1, notification);


		}
		// Keep this service running until it is explicitly stopped, so use sticky.
		return START_NOT_STICKY;
	}
	
	
	@Override
	public void onDestroy() {
		// Kill the Rx Modem thread
		if (m != null) {
			m.stopRxModem();
		}
	}  



	//Post to main terminal window
	public static void PostToTerminal(String text) {
		Processor.mainwindow += text;
		AndFlmsg.mHandler.post(AndFlmsg.addtoterminal);
	}


	//Post to main terminal window
	public static void PostToModem(String text) {
		Processor.monitor += text;
		AndFlmsg.mHandler.post(AndFlmsg.addtomodem);
	}


	//Post to main terminal window
	public static void PostToAPRS(String text) {
		Processor.APRSwindow += text;
		AndFlmsg.mHandler.post(AndFlmsg.addtoAPRS);
	}




	//Process one block of received data. Called from Modem.RxBlock when a complete 
	//  block is received
	public static void ProcessBlock(String Blockline) {
		FileWriter out = null;
		try {
			//JD To-Do: Flmsg processing (lf/cr reformat, CRC check, file name building, duplicate check...)
			PostToTerminal(Blockline);	
			File msgReceivedFile = new File(Processor.HomePath + 
			  Processor.Dirprefix + "Received" + Processor.Separator + Processor.FileNameString);
			if (msgReceivedFile.exists()) {
				msgReceivedFile.delete();
			}
			out = new FileWriter(msgReceivedFile, true);
			// out.write("\nSent at: " + Processor.myTime());
			out.write(Blockline);
			out.close();
			
		} catch (Exception ex) {
			Logger.getLogger(Processor.class.getName()).log(Level.SEVERE, null, ex);

		} 
	} // end Main

	/**
	 * Add a server to the array of known servers, for instance as written by the user
	 * @param MyServer
	 */
	public static void AddServerToArray(String myServer){           
		try {
			int i;
			boolean knownserver = false;
			for (i = 0; i < 10; i++) {
				if (myServer.equals(Servers[i])) {
					knownserver = true;
					break;
				}
			}

			if (!knownserver) {
				for (i = 0; i < 10; i++) {
					if (Servers[i].equals("")) {
						Servers[i] = myServer;
						//JD later on                          mainui.addServer(myServer);
						break;
					}
				}
			}
		} 
		catch (Exception e) {
			loggingclass.writelog("Had problem adding server to array, full?", e, true);
		}
	}

	/**
	 * Create or check the necessary folder structure 
	 */
	public static void handlefolderstructure(){
		
		try {
			//VK2ETA Changed to SD card device           HomePath = System.getProperty("user.home");
			//VK2ETA FIX: add exception here when there is no external storage
			HomePath = Environment.getExternalStorageDirectory().getAbsolutePath();
			// are we on Linux?
			if (File.separator.equals("/")) {
				Separator = "/";
				Dirprefix = "/NBEMS.files/";
				onWindows = false;
			} else  {
				Separator = "\\";
				Dirprefix = "\\NBEMS.files\\";
				onWindows = true;
			}

			//Check if base directory exists, create if not
			File baseDir = new File(HomePath + Dirprefix);
			if (!baseDir.isDirectory()) {
				baseDir.mkdir();
			}

			//Check if Outbox directory exists, create if not
			File outboxDir = new File(HomePath + Dirprefix + "Outbox" + Separator);
			if (!outboxDir.isDirectory()) {
				outboxDir.mkdir();
			}
			
			//Check if Received directory exists, create if not
			File receivedDir = new File(HomePath + Dirprefix + "Received" + Separator);
			if (!receivedDir.isDirectory()) {
				receivedDir.mkdir();
			}
			
			//Check if Templates directory exists, create if not
			File templateDir = new File(HomePath + Dirprefix + "Templates" + Separator);
			if (!templateDir.isDirectory()) {
				templateDir.mkdir();
			}

			/*
			
			//Check if Downloads directory exists, create if not
			File downloads = new File(HomePath + Dirprefix + "Downloads" + Separator);
			if (!downloads.isDirectory()) {
				downloads.mkdir();
			}

			*/
			
			//Check if Temporary html directory exists, create if not
			tempHtmlDir =   HomePath + Dirprefix + "TempHtml"+ Separator;
			pending = new File(tempHtmlDir);
			if (!pending.isDirectory()) {
				pending.mkdir();
			}
			
			// Now clears this directory of temporary files
			// Get the list of files in the outbox
			File tempHtmlFolder = new File(Processor.HomePath + Processor.Dirprefix
								+ "TempHtml");
			File[] files = tempHtmlFolder.listFiles(); // This filter only returns files
			FileFilter fileFilter = new FileFilter() {
				public boolean accept(File file)
				{
					return file.isFile();
				}
			};

			// We should now have an array of strings containing the file names
			files = tempHtmlFolder.listFiles(fileFilter);
			for (int i = 0; i < files.length; i++)
			{
				files[i].delete();
			}
			
						
			Pendingdir = HomePath + Dirprefix + "Pending" + Separator;
			Outpendingdir = HomePath + Dirprefix + "Outpending" + Separator;
			Transactions = HomePath + Dirprefix + "Transactions";

			/*
			
			// Check if bulletin file  exists, create if not
			File fFile = new File(Processor.HomePath + Processor.Dirprefix + "Downloads" + Separator + "bulletins");
			if (!fFile.exists()) {
				fFile.createNewFile();
			}
			bulletin = new FileWriter(fFile, true);

			// check if headers file exists, and read in contents 
			File fh = new File(HomePath + Dirprefix + "headers");
			if (!fh.exists()) {
				fh.createNewFile();
			}

			hdr = new FileReader(fh);
			BufferedReader br = new BufferedReader(hdr);
			String s;
			while ((s = br.readLine()) != null) {
				String fl = s + "\n";
				Mailheaderswindow += fl;
			}
			br.close();    
			
			*/
		}
		catch(Exception ex){
			loggingclass.writelog("Problem when handling pskmail folder structure.", ex, true);
		}
	}

	private static void handleinitialization(){

		try {
			Passwrd = AndFlmsg.myconfig.getPreference("PASSWORD","");
			// try to initialize MAXDCD from Prefs
			DCDstr = AndFlmsg.myconfig.getPreference("DCD","0");
			MAXDCD = Integer.parseInt(DCDstr);
			// try to initialize Icon from Prefs
			Icon = AndFlmsg.myconfig.getPreference("ICON","y");
			// Initialize APRSMessageNumber
			APRSMessageNumber = 0;
			// Initialize send queue
			TX_Text = "";
			// Modem settings
			//                host = configuration.getPreference("MODEMIP", "localhost");
			//                port = Integer.parseInt(configuration.getPreference("MODEMIPPORT", "7322"));
			ModemPreamble = AndFlmsg.myconfig.getPreference("MODEMPREAMBLE");
			ModemPostamble = AndFlmsg.myconfig.getPreference("MODEMPOSTAMBLE");
			// Mail settings
			compressedmail = AndFlmsg.myconfig.getPreferenceB("COMPRESSED");
			String profile = AndFlmsg.myconfig.getPreference("BLOCKLENGTH");
			CurrentModemProfile = profile;
			Character c =  profile.charAt(0);
			int profilenr = c.charValue() - 48;

			if (profilenr > 7 & profilenr > 1) {
				Processor.defaultmode = modemmodeenum.PSK250;
			} else {
				Processor.defaultmode = modemmodeenum.PSK250;
			}
			modeprofile  = new modemmodeenum[10];

			/*
// integrated GPS only at present
               if (AndPskmail.myconfig.getPreference("GPSD").equals("1")){
                   WantGpsd = true;
               }
               if (AndPskmail.myconfig.getPreference("SCANNER").equals("yes")) {
                    wantScanner = true;
               }
               // APRSServerSettings
               //
					aprsserverport=Integer.parseInt(AndPskmail.myconfig.getPreference("APRSSERVERPORT"));
               if (AndPskmail.myconfig.getPreference("APRSSERVER").equals("yes")) {
                   aprsserverenabled = true;
               } else {
                   aprsserverenabled = false;
               }
			 */

		} catch (Exception e) {
			MAXDCD = 3;
			q.backoff = "5";
			Icon = "y";
			loggingclass.writelog("Problems with config parameter.", e, true);
		}
		// Send Link request
		//           q.set_txstatus(txstatus.TXlinkreq);
		//           q.send_link();

//		Servers[0] = AndPskmail.myconfig.getPreference("SERVER");
		Servers[0] = AndFlmsg.serverToCall;
		Processor.myserver = Servers[0];
		Processor.mycall = AndFlmsg.myconfig.getPreference("CALL");
		//            Freq_offset = Integer.parseInt(Main.AndPskmail.myconfig.getPreference("RIGOFFSET"));

		/* No need here
            String XMLIP = AndPskmail.myconfig.getPreference("MODEMIP");

            if (XMLIP.equals("localhost")) {
                XMLIP = "127.0.0.1"; 
            }

             XmlRpc_URL = "http://" + XMLIP + ":7362/RPC2";
		 */

	}

	/* review all of this for integrated GPS in Android

   private static void handlegpsd() {
        try {
            // Connect to gpsd at port 2947 on localhost
            InetAddress addr = InetAddress.getByName("localhost");
            int target = 2947;
            SocketAddress sockaddr = new InetSocketAddress(addr, target);

            // Block no more than timeoutMs.
            // If the timeout occurs, SocketTimeoutException is thrown.

            int timeoutMs = 2000;   // 2 seconds

            gpsdSocket = new Socket();
            gpsdSocket.connect(sockaddr, timeoutMs);
            gpsdout = new PrintWriter(gpsdSocket.getOutputStream(), true);
            gpsdin = new BufferedReader(new InputStreamReader(
            gpsdSocket.getInputStream()));

            String outgps = "?WATCH={\"enable\":true, \"nmea\":true };";
            gpsdout.println(outgps);

            long t0 = System.currentTimeMillis();
            t1 = t0;

            boolean ready = false;

            while (t1 - t0 < 2000 & !ready){

                t1 = System.currentTimeMillis();

                String myRead = "";

                if (gpsdin.ready()) {
                    myRead = gpsdin.readLine();

                    if (myRead.substring(0,6).equals("$GPRMC")) {
                       HaveGPSD = true;
                       ready = true;
                    }
                }

            }

            if (!HaveGPSD) {
                q.Message ("Problem with GPSD", 10);
            }

        } catch (UnknownHostException e) {
                        q.Message ("Cannot find GPSD", 10);
                        HaveGPSD = false;
        } catch (IOException e) {
                        q.Message ("Cannot find gpsd", 10);
                        HaveGPSD = false;
        }

        if (HaveGPSD) {
            gpsdata = new nmeaparser();     // Parser for nmea data
            q.Message("Connected to GPSD", 10);
        }

   }
	 */

	/* not used. Review if required
   static public void getgpsddata() {
             String myRead = "";
             Boolean ready = false;

             while (HaveGPSD & !ready) {

                   try {
                        myRead = gpsdin.readLine();
                   } catch (IOException ex) {
                        Logger.getLogger(Main.class.getName()).log(Level.SEVERE, null, ex);
                   }

                   if (myRead.length() > 6 ){
                        if (myRead.substring(0,6).equals("$GPRMC")) {
                            gpsd_data = myRead.split(",");
                            if (gpsd_data[1].length() > 2) {
                                gpsdata.validfix = true;
                                gpsdata.fixat = gpsd_data[1];
                            }

                            gpsdata.latitude = gpsd_data[3];
                            float latdata = Float.valueOf(gpsdata.latitude)/100;
                            int degr = (int)latdata;
                            float mindata = (latdata - degr)/60*100;
                            mindata = degr + mindata;
                            if (gpsd_data[4].equals("S")) {
                                mindata *= -1;
                            }
                            GPSD_latitude = Float.toString(mindata);

                            gpsdata.longitude = gpsd_data[5];
                            float longdata = Float.valueOf(gpsdata.longitude)/100;
                            degr = (int)longdata;
                            mindata = (longdata - degr)/60*100;
                            mindata = degr + mindata;
                            if (gpsd_data[6].equals("S")) {
                                mindata *= -1;
                            }
                            GPSD_longitude = Float.toString(mindata);

                            gpsdata.speed = gpsd_data[7];
                            gpsdata.course = gpsd_data[8];

                            char[] buffer = new char [ 4000 ];
                        try {
                            int cnt = gpsdin.read(buffer);
                         } catch (IOException ex) {
                            Logger.getLogger(Main.class.getName()).log(Level.SEVERE, null, ex);
                         }
                      }

                            AndPskmail.myconfig.setLatitude(GPSD_latitude);
                            AndPskmail.myconfig.setLongitude(GPSD_longitude);

                            ready = true;
                  }




                 }

   }

static  public void parsenmeadata(String nmeadata){
        gpsdata.newdata(nmeadata);
            if (gpsdata.getFixStatus()){
                AndPskmail.myconfig.setLatitude(gpsdata.getLatitude());
                AndPskmail.myconfig.setLongitude(gpsdata.getLongitude());
                AndPskmail.myconfig.setSpeed(gpsdata.getSpeed());
                AndPskmail.myconfig.setCourse(gpsdata.getCourse());
            }
}
	 */
	/**
	 * Open a GPS connection, if that should be used
	 */
	private static void handlegps(){
		/* review this for Android
       // GPS
       gpsport = new serialport();       // Serial port object
       gpsdata = new nmeaparser();     // Parser for nmea data
       String portforgps = AndPskmail.myconfig.getPreference("GPSPORT");

       // Make sure the selected port still exists!
       if (AndPskmail.myconfig.getPreference("GPSENABLED").equals("yes")){
            if (!gpsport.checkComPort(portforgps)){
                Main.log.writelog("Serial port "+portforgps+" does not exist! Was the GPS removed? Disabling GPS.", true);
                AndPskmail.myconfig.setPreference("GPSENABLED", "no");
            }
       }

       if (AndPskmail.myconfig.getPreference("GPSENABLED").equals("yes")){
       try
       {
            String speedforgps = AndPskmail.myconfig.getPreference("GPSSPEED");
            int speedygps = Integer.parseInt(speedforgps);
            gpsport.connect(portforgps,speedygps);
            // Check if the port is open
            if (!gpsport.curstate){
                // Disconnect and set it off
                gpsport.disconnect();
                AndPskmail.myconfig.setPreference("GPSENABLED", "no");
            }
            // if (portforgps.contains("USB"))
            // Here is the code for getting a gps out of sirf mode
			// gpsdata.writehexsirfmsg("8102010100010101050101010001000100010001000112c0"); //Set 4800 bps nmea
       }
       catch(Exception ex)
       {
            log.writelog("Error when trying to connect to the GPS.", ex, true);
       }
      }   
		 */
	}



	static String getTXModemString (modemmodeenum mode) {
		try {
			String Txmodemstring = "";
			Txmodemstring = Modem.getModemString(mode);
			return Txmodemstring;
		} catch (Exception e) {
			return "";
		}
	}
	static String getAltTXModemString (modemmodeenum mode) {
		String Txmodemstring = "";
		Txmodemstring = Modem.getAltModemString(mode);
		return Txmodemstring;
	}

	/* not used
   static void setFreq (String freq) {
       if (Rigctl.opened) {
           int fr = Integer.parseInt(Main.CurrentFreq) + Rigctl.OFF;
           freqstore = Integer.toString(fr);
           Rigctl.Setfreq(freq);
           summoning = true;
       }
   }
	 */

	static void savePreferences()  {
		try {
			// store the config file if present

			File f1 = new File( "configuration.xml");
			File f2 = new File(Processor.HomePath + Processor.Dirprefix + "configuration.xml");

			if (f1.isFile()) {

				InputStream in = new FileInputStream(f1);

				//Overwrite the file.
				OutputStream out = new FileOutputStream(f2);

				byte[] buf = new byte[1024];
				int len;
				while ((len = in.read(buf)) > 0){
					out.write(buf, 0, len);
				}
				in.close();
				out.close();
				q.Message("Config File stored.", 10);
			}
		}
		catch (Exception e) {
			q.Message("problem writing the config file", 10);
		}
	}


	static double decayaverage(double oldaverage, double newvalue, double factor)  {

		double newaverage = oldaverage;
		if (factor > 1) {
			newaverage = (oldaverage * (1 - 1 / factor)) + (newvalue / factor);
		}
		return newaverage;
	}

	/* TTY not implemented in Android
//Downgrade RX and TX modes alternatively (until we recover the link)
 static void DowngradeOneMode()  {
    int currentmodeindex = 0;

    if (Main.JustDowngradedRX) {
        JustDowngradedRX = false;
        Main.hiss2n = 50; //Reset to mid-range
        if (Main.UseAlttable) {
            currentmodeindex = m.getAltModemPos(Main.TxModem);
            if (currentmodeindex > 1) {
                Main.TxModem = m.getaltmode(currentmodeindex - 1);
            }
        } else {
            currentmodeindex = m.getAltModemPos(Main.TxModem);
            if (currentmodeindex > 1) {
                Main.TxModem = m.getmode(currentmodeindex - 1);
            }
        }
    } else {
         JustDowngradedRX = true;
         Main.mys2n = 50; //Reset to mid-range
         if (Main.UseAlttable) {
                currentmodeindex = m.getAltModemPos(Main.RxModem);
                if (currentmodeindex > 1) {
                    Main.RxModem = m.getaltmode(currentmodeindex - 1);
                    Main.RxModemString = m.getAltModemString(Main.RxModem);
                    blocktime = m.getBlockTime (Main.RxModem);
                }
          } else {
                currentmodeindex = m.getAltModemPos(Main.RxModem);
                if (currentmodeindex > 1) {
                    Main.RxModem = m.getmode(currentmodeindex - 1);
                    Main.RxModemString = m.getModemString(Main.RxModem);
                    blocktime = m.getBlockTime (Main.RxModem);
                }
          }
   }
 }

 static void ChangeMode ( modemmodeenum Modem) {
         String SendMode = "";
        if (UseAlttable) {
             SendMode ="<cmd><mode>" + getAltTXModemString(Modem) + "</mode></cmd>";
        } else {
            SendMode ="<cmd><mode>" + getTXModemString(Modem) + "</mode></cmd>";
        }
        m.Sendln(SendMode);
        try {
            Thread.sleep(250);
        } catch (InterruptedException ex) {
            Logger.getLogger(Main.class.getName()).log(Level.SEVERE, null, ex);
        }
        if (Sendline.length() > 0) {
            m.Sendln(Sendline);
            Main.TXActive = true;
        }
        Sendline = "";

 }
	 */

	static String myTime () {
		// create a java calendar instance
		Calendar calendar = Calendar.getInstance();

		// get a java.util.Date from the calendar instance.
		// this date will represent the current instant, or "now".
		java.util.Date now = calendar.getTime();

		// a java current time (now) instance
		java.sql.Timestamp currentTimestamp = new java.sql.Timestamp(now.getTime());

		return currentTimestamp.toString().substring(0,16);
	}


	static void log (String logtext) {
		//           File consolelog = new File (HomePath + Dirprefix + "logfile");
		try{
			// Create file
			FileWriter logstream = new FileWriter(HomePath + Dirprefix + "logfile", true);
			BufferedWriter out = new BufferedWriter(logstream);

			out.write(myTime() + " " + logtext + "\n");
			//Close the output stream
			out.close();

		}catch (Exception e){//Catch exception if any
			//              System.err.println("LogError: " + e.getMessage());
			loggingclass.writelog("LogError " + e.getMessage() , null, true);
		}
		Processor.PostToTerminal(myTime() + " " + logtext + "\n");
	}


	@Override
	public IBinder onBind(Intent arg0) {
		// Nothing here, not used
		return null;
	}


} // end Main class



